package com.example.hello14;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.support.v4.content.FileProvider;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

public class MainActivity extends Activity implements View.OnClickListener {

    private Button mBtOpenSystemCamrea;
    private Button mBtOpenMyselfCamrea;
    private Button mBtOpenFixedCamera;
    private ImageView mImageView;
    private static final Integer RESULT_SYSTEM = 1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        findView();
        setListener();
    }

    private void setListener() {
        mBtOpenSystemCamrea.setOnClickListener(this);
        mBtOpenMyselfCamrea.setOnClickListener(this);
        mBtOpenFixedCamera.setOnClickListener(this);
    }

    private void findView() {
        mBtOpenSystemCamrea = findViewById(R.id.open_system_camera);
        mBtOpenMyselfCamrea = findViewById(R.id.open_myself_camera);
        mBtOpenFixedCamera = findViewById(R.id.open_update_camera);
        mImageView =findViewById(R.id.image_view);
    }

    @Override
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.open_system_camera:
                openSystemCamrea();
                break;

            case R.id.open_myself_camera:
                openMyselfCamera();
                break;
            case R.id.open_update_camera:
                openUpdateCamera();
                break;
        }
    }

    private void openUpdateCamera() {
        Intent intent = new Intent();
        intent.setAction(MediaStore.ACTION_IMAGE_CAPTURE);
        //File file = new File(getExternalFilesDir(""),"photo1.jpg");
        File file = new File(Environment.getExternalStorageDirectory(),"zPhotoP.jpg");
        Uri uri;
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
            uri = FileProvider.getUriForFile(this,"com.example.image",file);
        }else {
            uri = Uri.fromFile(file);
        }
        Uri uri1 = FileProvider.getUriForFile(this,"com.example.image",file);
        Uri uri2 = Uri.fromFile(file);
        intent.putExtra(MediaStore.EXTRA_OUTPUT,uri);
        startActivityForResult(intent,0);
    }

    //打开系统相机
    private void openSystemCamrea() {
        Intent intent = new Intent();
        intent.setAction(MediaStore.ACTION_IMAGE_CAPTURE);
        //原图保存
        File file = new File(getExternalFilesDir(""),"photo.jpg");
        Uri uri = Uri.fromFile(file);                       //file的唯一资源标识符uri
        intent.putExtra(MediaStore.EXTRA_OUTPUT,uri);     //使用intent连接照相机的输出到uri
        startActivityForResult(intent,1);      //调回函数onAtcitivyResult()，requestCode标识该调回
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        File file;
        Bitmap bitmap = null;
        if(resultCode == RESULT_OK) {
            switch (requestCode) {
                case 1:
                    //显示图片
                    /*Bitmap bitmap = (Bitmap) data.getExtras().get("data");  //获取返回结果的缩略图
                    mImageView.setImageBitmap(bitmap);                      //使用ImageView显示位图*/

                    //保存图片，由于图片较大，保存在外部存储，路径为storage/emulated/0/Android/data/files下
                    file = new File(getExternalFilesDir(""), "photo.jpg");

                    try {
                        bitmap = BitmapFactory.decodeStream(new FileInputStream(file));
                    } catch (FileNotFoundException e) {
                        e.printStackTrace();
                    }
                    if (bitmap != null) {
                        mImageView.setImageBitmap(bitmap);
                    }
                    break;
                case 0:
                     file = new File(getExternalFilesDir(""),"photo1.jpg");
                    try {
                        bitmap = BitmapFactory.decodeStream(new FileInputStream(file));
                        mImageView.setImageBitmap(bitmap);
                    } catch (FileNotFoundException e) {
                        e.printStackTrace();
                    }
                    break;
            }
        }
    }

    //打开我的相机
    private void openMyselfCamera() {
        Intent intent = new Intent(MainActivity.this,MyCameraActivity.class);
        startActivity(intent);
    }

}
